searchNodes=[{"doc":"Nebulex adapter for Redis. This adapter is implemented using Redix, a Redis driver for Elixir.NebulexRedisAdapter provides three setup alternatives:Standalone - The adapter establishes a pool of connections with a single Redis node. The :standalone is the default mode.Redis Cluster - Redis Cluster is a built-in feature in Redis since version 3, and it may be the most convenient and recommendable way to set up Redis in a cluster and have a distributed cache storage out-of-box. This adapter provides the :redis_cluster mode to set up Redis Cluster from the client-side automatically and be able to use it transparently.Built-in client-side cluster based on sharding - This adapter provides a simple client-side cluster implementation based on Sharding distribution model via :cluster mode.Shared OptionsIn addition to Nebulex.Cache shared options, this adapters supports the following options::mode - Defines the mode Redis will be set up. It can be one of the next values: :standalone, :cluster, :redis_cluster. Defaults to :standalone.:pool_size - Number of connections in the pool. Defaults to System.schedulers_online().:conn_opts - Redis client options (Redix options in this case). For more information about connection options, see Redix docs.TTL or Expiration TimeAs is explained in Nebulex.Cache, most of the write-like functions support the :ttl option to define the expiration time, and it is defined in milliseconds. Despite Redis work with seconds, the conversion logic is handled by the adapter transparently, so when using a cache even with the Redis adapter, be sure you pass the :ttl option in milliseconds.Data TypesThis adapter only works with strings internally, which means the given Elixir terms are encoded to binaries before executing the Redis command. The encoding/decoding process is performed by the adapter under-the-hood, so it is completely transparent for the user.NOTE: Support for other Redis Data Types is in the roadmap.StandaloneWe can define a cache to use Redis as follows:defmodule MyApp.RedisCache do use Nebulex.Cache, otp_app: :nebulex, adapter: NebulexRedisAdapter endThe configuration for the cache must be in your application environment, usually defined in your config/config.exs:config :my_app, MyApp.RedisCache, conn_opts: [ host: &quot;127.0.0.1&quot;, port: 6379 ]Redis ClusterWe can define a cache to use Redis Cluster as follows:defmodule MyApp.RedisClusterCache do use Nebulex.Cache, otp_app: :nebulex, adapter: NebulexRedisAdapter endThe config:config :my_app, MyApp.RedisClusterCache, mode: :redis_cluster, master_nodes: [ [ host: &quot;127.0.0.1&quot;, port: 7000 ], [ url: &quot;redis://127.0.0.1:7001&quot; ], [ url: &quot;redis://127.0.0.1:7002&quot; ] ], conn_opts: [ # Redix options, except `:host` and `:port`; unless we have a cluster # of nodes with the same host and/or port, which doesn&#39;t make sense. ]Redis Cluster OptionsIn addition to shared options, :redis_cluster mode supports the following options::master_nodes - The list with the configuration for the Redis cluster master nodes. The configuration for each master nodes contains the same options as :conn_opts. The adapter traverses the list trying to establish connection at least with one of them and get the cluster slots to finally setup the Redis cluster from client side properly. If one fails, the adapter retries with the next in the list, that's why at least one master node must be set.:conn_opts - Same as shared options (optional). The :conn_opts will be applied to each connection pool with the cluster (they will override the host and port retrieved from cluster slots info). For that reason, be careful when setting :host or :port options since they will be used globally and can cause connection issues. Normally, we add here the desired client options except :host and :port. If you have a cluster with the same host for all nodes, in that case make sense to add also the :host option.:pool_size - Same as shared options (optional). It applies to all cluster slots, meaning all connection pools will have the same size.Client-side clusterWe can define a cache with &quot;client-side cluster mode&quot; as follows:defmodule MyApp.ClusteredCache do use Nebulex.Cache, otp_app: :nebulex, adapter: NebulexRedisAdapter endThe config:config :my_app, MyApp.ClusteredCache, mode: :cluster, nodes: [ node1: [ pool_size: 10, conn_opts: [ host: &quot;127.0.0.1&quot;, port: 9001 ] ], node2: [ pool_size: 4, conn_opts: [ url: &quot;redis://127.0.0.1:9002&quot; ] ], node3: [ conn_opts: [ host: &quot;127.0.0.1&quot;, port: 9003 ] ] ]By default, the adapter uses NebulexRedisAdapter.Cluster.Keyslot for the keyslot. Besides, if :jchash is defined as dependency, the adapter will use consistent-hashing automatically. However, you can also provide your own implementation by implementing the Nebulex.Adapter.Keyslot and set it into the :keyslot option. For example:defmodule MyApp.ClusteredCache.Keyslot do use Nebulex.Adapter.Keyslot @impl true def hash_slot(key, range) do # your implementation goes here end endAnd the config:config :my_app, MyApp.ClusteredCache, mode: :cluster, keyslot: MyApp.ClusteredCache.Keyslot, nodes: [ ... ]Client-side cluster optionsIn addition to shared options, :cluster mode supports the following options::nodes - The list of nodes the adapter will setup the cluster with; a pool of connections is established per node. The :cluster mode enables resilience to be able to survive in case any node(s) gets unreachable. For each element of the list, we set the configuration for each node, such as :conn_opts, :pool_size, etc.:keyslot - Defines the module implementing Nebulex.Adapter.Keyslot behaviour, used to compute the node where the command will be applied to. It is highly recommendable to provide a consistent hashing implementation.Queryable APISince the queryable API is implemented by using KEYS command:Only strings (String.t()) are allowed as query parameter.Only keys can be queried.Examplesiex&gt; MyApp.RedisCache.put_all(%{ ...&gt; &quot;firstname&quot; =&gt; &quot;Albert&quot;, ...&gt; &quot;lastname&quot; =&gt; &quot;Einstein&quot;, ...&gt; &quot;age&quot; =&gt; 76 ...&gt; }) :ok iex&gt; MyApp.RedisCache.all(&quot;**name**&quot;) [&quot;firstname&quot;, &quot;lastname&quot;] iex&gt; MyApp.RedisCache.all(&quot;a??&quot;) [&quot;age&quot;] iex&gt; MyApp.RedisCache.all() [&quot;age&quot;, &quot;firstname&quot;, &quot;lastname&quot;] iex&gt; stream = TestCache.stream(&quot;**name**&quot;) iex&gt; stream |&gt; Enum.to_list() [&quot;firstname&quot;, &quot;lastname&quot;] # get the values for the returned queried keys iex&gt; &quot;**name**&quot; |&gt; MyApp.RedisCache.all() |&gt; MyApp.RedisCache.get_all() %{&quot;firstname&quot; =&gt; &quot;Albert&quot;, &quot;lastname&quot; =&gt; &quot;Einstein&quot;}Using the cache for executing a Redis command or pipelineSince NebulexRedisAdapter works on top of Redix and provides features like connection pools and &quot;Redis Cluster&quot; support, it may be seen also as a sort of Redis client, but it is meant to be used mainly with the Nebulex cache API. However, Redis API is quite extensive and there are a lot of useful commands we may want to run taking advantage of the NebulexRedisAdapter features. Therefore, the adapter injects two additional/extended functions to the defined cache: command!/3 and pipeline!/3.`command!(key \\ nil, name \\ MODULE, command)iex&gt; MyCache.command!(&quot;mylist&quot;, [&quot;LPUSH&quot;, &quot;mylist&quot;, &quot;world&quot;]) 1 iex&gt; MyCache.command!(&quot;mylist&quot;, [&quot;LPUSH&quot;, &quot;mylist&quot;, &quot;hello&quot;]) 2 iex&gt; MyCache.command!(&quot;mylist&quot;, [&quot;LRANGE&quot;, &quot;mylist&quot;, &quot;0&quot;, &quot;-1&quot;]) [&quot;hello&quot;, &quot;world&quot;]`pipeline!(key \\ nil, name \\ MODULE, commands)iex&gt; cache.pipeline!(&quot;mylist&quot;, [ ...&gt; [&quot;LPUSH&quot;, &quot;mylist&quot;, &quot;world&quot;], ...&gt; [&quot;LPUSH&quot;, &quot;mylist&quot;, &quot;hello&quot;], ...&gt; [&quot;LRANGE&quot;, &quot;mylist&quot;, &quot;0&quot;, &quot;-1&quot;] ...&gt; ]) [1, 2, [&quot;hello&quot;, &quot;world&quot;]]NOTE: The key is required when used the adapter in mode :cluster or :redis_cluster, for :standalone no needed (optional). And the name is in case you are using a dynamic cache and you have to pass the cache name explicitly.","ref":"NebulexRedisAdapter.html","title":"NebulexRedisAdapter","type":"module"},{"doc":"Redis Cluster Node/Slot Supervisor.","ref":"NebulexRedisAdapter.RedisCluster.Supervisor.html","title":"NebulexRedisAdapter.RedisCluster.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NebulexRedisAdapter.RedisCluster.Supervisor.html#child_spec/1","title":"NebulexRedisAdapter.RedisCluster.Supervisor.child_spec/1","type":"function"}]